<template>
  <section class="vlue-dev-sidebar-section">
    <input class="vlue-dev-sidebar-button vlue-dev-sidebar-button-expand-collapse"
      type="button"
      v-on:click="toggleExpanded()"
      :value="expanded ? '-' : '+'">
    <slot name="top"></slot>
    <div class="vlue-dev-sidebar-section-content"
      :style="{ display: expanded ? 'block' : 'none' }">
      <slot></slot>
    </div>
  </section>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  data() {
    return {
      expanded: false,
    }
  },
  props: {
    expandedByDefault: Boolean,
  },
  created() {
    if (this.expandedByDefault) this.expanded = true;
  },
  methods: {
    toggleExpanded() {
      this.expanded = !this.expanded;
    }
  }
})
</script>

<style lang="scss">
#vlue-dev-sidebar .vlue-dev-sidebar-section {
  position: relative;
  border-top: 1px solid #0002;
  padding-top: 10px;
  .vlue-dev-sidebar-section h3 {
    padding-left: 20px;
  }
  .vlue-dev-sidebar-button.vlue-dev-sidebar-button-expand-collapse {
    position: absolute;
    top: 8px;
    right: 0;
    width: 20px;
    height: 20px;
    font-family: monospace;
    padding: 0;
    text-align: center;
    border-radius: 50%;
    background: #fff1;
    line-height: 20px;
    font-size: 10px;
    font-weight: bold;
    &:enabled:hover,
    &:enabled:active {
      padding: 0;
    }
  }
}
</style>
